'37_in_1, Photo Interrupter Module KY-010

$regfile = "m328pdef.dat"
$crystal = 16000000
$hwstack = 20
$swstack = 20
$framesize = 80

Dim Time_count As Word , O_min_1 As Single , O_min As Single
Dim Timer_mode As Byte , Timer_mode_old As Byte

Config Clockdiv = 1

$include "Arduino_pins.sub"                                 'include Arduino pin definitions

Config Arduino_pin#2 = Input
Arduino_port#2 = 1

Wait 1

Print "37_in_1 demo program 16"
Print "2 = digital input"
Print

Timer_mode_old = 9
Timer_mode = 3

Do
  If Timer_mode <> Timer_mode_old Then
    If Timer_mode = 1 Then
      Config Timer1 = Timer , Prescale = 1
      O_min = 16000000 * 60
    Elseif Timer_mode = 2 Then
      Config Timer1 = Timer , Prescale = 8
      O_min = 2000000 * 60
    Elseif Timer_mode = 3 Then
      Config Timer1 = Timer , Prescale = 64
      O_min = 250000 * 60
    Else
      Config Timer1 = Timer , Prescale = 1024
      O_min = 15625 * 60
    End If
    Timer_mode_old = Timer_mode
  End If

  Timer1 = 0
  Set Tifr1.tov1

  While Arduino_pin#2 = 0
    If Tifr1.tov1 = 1 Then Exit While
  Wend
  While Arduino_pin#2 = 1
    If Tifr1.tov1 = 1 Then Exit While
  Wend

  If Tifr1.tov1 = 0 Then
    Set Gtccr.psrsync                                       'reset prescaler
    Timer1 = 0
  End If

  While Arduino_pin#2 = 0
    If Tifr1.tov1 = 1 Then Exit While
  Wend
  While Arduino_pin#2 = 1
    If Tifr1.tov1 = 1 Then Exit While
  Wend

  If Tifr1.tov1 = 0 Then
    Time_count = Timer1
    If Time_count >= 2000 Then
      o_min_1 = o_min / Time_count
      Print "o/min = " ; Fusing(o_min_1 , "#.##")
      Waitms 990
    Elseif Timer_mode > 1 Then
      Decr Timer_mode
    Else
      Print "o/min >>"
      Waitms 990
    End If
  Else
    If Timer_mode < 4 Then
      Incr Timer_mode
    Else
      Print "o/min <<"
    End If
  End If
  Waitms 10
Loop

End